nSampleIterations <- 15625;
#set values
rangeS <- c(0, 0.1);
rangeH <- c(1, 1);
rangeH2 <- c(1, 1);
rangeH3 <- c(1,1);
rangePopSize <- c(50, 5000);
arrStartingAncestryProps <- c(0.5,0.72);
rangeGen <- c(40,70);

sOutFilePrefix <- "ABC_ret_uniforms_drift_tlmc_";


arrObsDeparture <- NULL;

sObsDepartures <- "sample_input_tlmc.txt";
nLocusSize <- -1;#do not touch.

w_scenario1<-function(s, h1, h2, h3){matrix(c(
                        1,       1,         1-h2*s,     1-h1*s,
                        1,       1,         1-h1*s,     1,
                        1-h2*s,  1-h1*s,    1-h3*s,     1-h2*s,
                        1-h1*s,  1,         1-h2*s,     1
                        ), nrow=4,ncol=4)}
						
w_scenario2<-function(s, h1, h2, h3){matrix(c(
                        1,       1-s,         1,     1-h1*s,
                        1-s,       1-s,         1-s,     1-s,
                        1,  1-h1*s,    1,     1,
                        1-h1*s,  1-s,         1,     1
                        ), nrow=4,ncol=4)}


arrArgs <- commandArgs(trailingOnly = TRUE);
nTimeToSleep <- 5 * as.numeric(arrArgs[1]);
cat("Sleeping for ", nTimeToSleep, " seconds\n");						
Sys.sleep(nTimeToSleep);

#This function names files iteritatively so that you can just submit jobs with sleep
fnGetNextUsableOutputName <- function() {
	i <- 0;
	while(TRUE) {
		sFileRet <- paste(sOutFilePrefix, i, ".txt", sep="");
		if (!file.exists(sFileRet)) {	
			write.table("Starting_Ancestry_Prop	S	H1	H2	H3	Gen	LociMat1	LociMat2	PopSize	Dist_HaploMean	Dist_HaploVar	DistDepartMean	DistDepartVar	MEAN_M_M	MEAN_B_B	MEAN_H_H	MEAN_SH1	MEAN_SH2	MEAN_SH3	MEAN_SH4	MEAN_M_B	MEAN_B_M	VAR_M_M	VAR_B_B	VAR_H_H	VAR_SH1	VAR_SH2	VAR_SH3	VAR_SH4	VAR_M_B	VAR_B_M	MEAN_d_M_M	MEAN_d_B_B	MEAN_d_H_H	MEAN_d_SH1	MEAN_d_SH2	MEAN_d_SH3	MEAN_d_SH4	MEAN_d_M_B	MEAN_d_B_M	VAR_d_M_M	VAR_d_B_B	VAR_d_H_H	VAR_d_SH1	VAR_d_SH2	VAR_d_SH3	VAR_d_SH4	VAR_d_M_B	VAR_d_B_M	W1_E_M_M	W1_E_B_B	W1_E_H_H	W1_E_SH1	W1_E_SH2	W1_E_SH3	W1_E_SH4	W1_E_M_B	W1_E_B_M	W2_E_M_M	W2_E_B_B	W2_E_H_H	W2_E_SH1	W2_E_SH2	W2_E_SH3	W2_E_SH4	W2_E_M_B	W2_E_B_M	AncProp", sFileRet , append=FALSE, quote = FALSE, col.names = FALSE, row.names = FALSE);
			return(sFileRet);
		}
		else {
			i=i+1;
		}
	}
}

#run function to get next outfile name
sOutFile <- fnGetNextUsableOutputName();

fnGetObsDepartures <- function(sIn) {
	dat <- read.table(sIn, header=TRUE);
	arrRetHaplotype <- NULL;
	arrRetDeparture <- NULL;
	vIndNumber <- NULL;

#read in data
	for(r in 1:nrow(dat)) {
		#x <- as.numeric(dat[r , ]);
			
		#arrRet <- rbind(arrRet, fnCalcDeparture(as.numeric(dat[r,])));
		arrRetHaplotype <- rbind(arrRetHaplotype, as.numeric(dat[r,2:10]));
		arrRetDeparture <- rbind(arrRetDeparture, as.numeric(dat[r,11:19]));
		vIndNumber <- c(vIndNumber, as.numeric(dat[r,1]) );
	}
	
	return(list(Haplo=arrRetHaplotype, Depart=arrRetDeparture, IndNum=vIndNumber, LociCount=nrow(dat)));
}

arrObsDeparture <- fnGetObsDepartures(sObsDepartures);

fnSimulation <- function(x, nMaxGen,w, arrPopSizes, nLocusIndex) { #arrPopSizes is a vector of pop sizes, index being generation.

	arrDistances <- numeric(nMaxGen);
	arrAncProp <- numeric(nMaxGen);


	# fitness table
	# w11 and w44 are conspecific homozygotes; w22 and w33 are heterospecific homozygotes, and so on

	
	# store haplotype frequency over generations
	#X<-x
	# disequilibrium
	d <- x[1]*x[4] - x[2]*x[3]; 
	
	w_mean<-0
	for (j in 1:4){
		for (k in 1:4){
			w_mean = w_mean + as.numeric(x[j]*x[k]*w[j,k])
		}
	}
	#w_bar<-w_mean

	for (z in 1:nMaxGen){ # number of generations

	# disequilibrium
		D = x[1]*x[4] - x[2]*x[3]; #D
		d<-c(d,as.numeric(D))
		
	# Anc Prop
		nAncProp <- (x[1]*2 + x[2] + x[3])/2;
		
	#converting into MSG genotypes
	M_M<-x[1]^2; #homozygous malinche both loci
	B_B<-x[4]^2; #homozygous birchmanni both loci
	H_H<- 2*x[1]*x[4] + 2*x[2]*x[3]; #double heterozygotes	
	SH1<- 2*x[2]*x[4]; #BM_BB
	SH2<-2*x[3]*x[4]; #BB_BM
	SH3<- 2*x[2]*x[1]; #MM_BM
	SH4<- 2*x[3]*x[1]; #BM_MM
	M_B<-x[2]^2; #opposite homozygous MM_BB
	B_M<-x[3]^2; #opposite homozygous BB_MM

	#sanity check
	total=sum(M_M+B_B+H_H+SH1+SH2+SH3+SH4+M_B+B_M)
	
		
		if (nMaxGen == z) { # reach the end of iteration of generations, return result.
		
		
			#Add noise , for n Loci in input dataset
			#nLoci = arrObsDeparture[["LociCount"]]; #now nLoci is passed in externally
			arrFH <- NULL;
			arrD <- NULL;
			#from allele frequencies assuming random mating
			f_M1=x[1]+x[2]
			f_M2=x[1]+x[3]
			E_M_M<-(f_M1^2)*(f_M2^2)
			E_B_B<-((1-f_M1)^2)*((1-f_M2)^2)
			E_H_H<-2*(f_M1)*(1-f_M1)*2*(f_M2)*(1-f_M2)
			E_SH1<-2*(f_M1)*(1-f_M1)*(1-f_M2)^2 #BM_BB
			E_SH2<-2*(f_M2)*(1-f_M2)*(1-f_M1)^2 #BB_BM
			E_SH3<-2*(f_M2)*(1-f_M2)*f_M1^2 #MM_BM
			E_SH4<-2*(f_M1)*(1-f_M1)*f_M2^2 #BM_MM
			E_M_B<-(f_M1^2)*((1-f_M2)^2)
			E_B_M<-(f_M2^2)*((1-f_M1)^2)
			

#run the function calculating means and variances
			#Add sampling error:
			nSampledIndSize <- arrObsDeparture[["IndNum"]][[nLocusIndex]];
			freqs_sample<-rmultinom(1,nSampledIndSize, fnAdjustSmallNegatives(c(M_M,B_B,H_H,SH1,SH2,SH3,SH4,M_B,B_M )));
			
			M_M_new <- freqs_sample[1,]/nSampledIndSize;
			B_B_new <- freqs_sample[2,]/nSampledIndSize;
			H_H_new <- freqs_sample[3,]/nSampledIndSize;
			SH1_new <- freqs_sample[4,]/nSampledIndSize;
			SH2_new <- freqs_sample[5,]/nSampledIndSize;
			SH3_new <- freqs_sample[6,]/nSampledIndSize;
			SH4_new <- freqs_sample[7,]/nSampledIndSize;
			M_B_new <- freqs_sample[8,]/nSampledIndSize;
			B_M_new <- freqs_sample[9,]/nSampledIndSize;
			
			#arrDistances <- fnObjectiveFunc(arrFH , arrD );
			d_M_M<-(M_M_new-E_M_M)/(E_M_M+1)
			d_B_B<-(B_B_new-E_B_B)/(E_B_B+1)
			d_H_H<-(H_H_new-E_H_H)/(E_H_H+1)
			d_SH1<-(SH1_new-E_SH1)/(E_SH1+1)
			d_SH2<-(SH2_new-E_SH2)/(E_SH2+1)
			d_SH3<-(SH3_new-E_SH3)/(E_SH3+1)
			d_SH4<-(SH4_new-E_SH4)/(E_SH4+1)
			d_M_B<-(M_B_new-E_M_B)/(E_M_B+1)
			d_B_M<-(B_M_new-E_B_M)/(E_B_M+1)
				
			arrAncProp <- nAncProp;
			return(list(FH=fnAdjustSmallNegatives(c(M_M_new,B_B_new,H_H_new,SH1_new,SH2_new,SH3_new,SH4_new,M_B_new,B_M_new )), D=c(d_M_M, d_B_B, d_H_H, d_SH1, d_SH2, d_SH3, d_SH4, d_M_B, d_B_M), Prop=arrAncProp, RandomMatingHaplo=c(E_M_M,E_B_B,E_H_H,E_SH1,E_SH2,E_SH3,E_SH4,E_M_B,E_B_M )));
		}
		
	# marginal fitnesses
		wstar<-{}
		for (i in 1:4){
		wstar<-c(wstar, x[1]*w[i,1] + x[2]*w[i,2] + x[3]*w[i,3] + x[4]*w[i,4])
		}
		
	# mean fitness
		w_mean<-0
		for (j in 1:4){
			for (k in 1:4){
				w_mean = w_mean + as.numeric(x[j]*x[k]*w[j,k])
			}
		}
		#w_bar<-c(w_bar, w_mean)
		
	# new hap freqs
	y<-{}
	y<-c(y,as.numeric(round(x[1]*(wstar[1]/w_mean)-(0.5*D*w[1,4]/w_mean),5)))
	y<-c(y,as.numeric(round(x[2]*(wstar[2]/w_mean)+(0.5*D*w[1,4]/w_mean),5)))
	y<-c(y,as.numeric(round(x[3]*(wstar[3]/w_mean)+(0.5*D*w[1,4]/w_mean),5)))
	y<-c(y,as.numeric(round(x[4]*(wstar[4]/w_mean)-(0.5*D*w[1,4]/w_mean),5)))
	
	#Add drift based on population size.
	nPopulationSize <- arrPopSizes[z];
	arrResampled<-rmultinom(1,nPopulationSize,fnAdjustSmallNegatives(y));
			
	#these are the actual frequencies but with noise added from the multinomial
	x <- {};
	x <- c(x, arrResampled[1,]/nPopulationSize);
	x <- c(x, arrResampled[2,]/nPopulationSize);
	x <- c(x, arrResampled[3,]/nPopulationSize);
	x <- c(x, arrResampled[4,]/nPopulationSize);
	
		
		#X<-rbind(X,as.numeric(y)) # store info 
		
	} # for numreps


	
	
	
}# end simulation function

#calculate and output means and variances and other summary statistics

vRealHaploMeans <- apply(arrObsDeparture[["Haplo"]] , 2,function(x){mean(x,na.rm=TRUE)});
vRealHaploVars <- apply(arrObsDeparture[["Haplo"]] , 2, function(x){var(x,na.rm=TRUE)});
vRealDepartMeans <- apply(arrObsDeparture[["Depart"]] , 2, function(x){mean(x,na.rm=TRUE)});
vRealDepartVars <- apply(arrObsDeparture[["Depart"]] , 2, function(x){var(x,na.rm=TRUE)});

#function to calculate a bunch of summary statistics, assign them names that are used below
fnObjectiveFunc <- function(arrHaplotypeFreq , arrDepartures, arrProp) { #Calculate objective function as mean squared difference between observed and predicted departures summed across all loci.
	
	vSimHaploMeans <- apply(arrHaplotypeFreq , 2, function(x){mean(x,na.rm=TRUE)});
	vSimHaploVars <- apply(arrHaplotypeFreq , 2, function(x){var(x,na.rm=TRUE)});
	
	vSimDepartMeans <- apply(arrDepartures , 2, function(x){mean(x,na.rm=TRUE)});
	vSimDepartVars <- apply(arrDepartures , 2, function(x){var(x,na.rm=TRUE)});
	
	nDistHaploMean <- sqrt(sum((vRealHaploMeans - vSimHaploMeans)^2));
	nDistHaploVar <- sqrt(sum((vRealHaploVars - vSimHaploVars)^2));
	
	nDistDepartMean <- sqrt(sum((vRealDepartMeans - vSimDepartMeans)^2));
	nDistDepartVar <- sqrt(sum((vRealDepartVars - vSimDepartVars)^2));
	
	return(list(DistHaploMean=nDistHaploMean, DistHaploVar=nDistHaploVar, DistDepartMean=nDistDepartMean, DistDepartVar=nDistDepartVar, SimHaploMeans=vSimHaploMeans, SimHaploVars=vSimHaploVars, SimDepartMeans=vSimDepartMeans, SimDepartVars=vSimDepartVars, Prop=mean(arrProp)));
}

 fnAdjustSmallNegatives <- function(v) {
	v[v<0] <- 0;
	return(v);
}

#Draw new priors
for( nIt in 1:nSampleIterations) {

	#randomly draw from prior distribution
	nAnc <- runif(1 , arrStartingAncestryProps[[1]], arrStartingAncestryProps[[2]] );
	nS <- runif(1 , rangeS[[1]], rangeS[[2]]);
	nH <- runif(1 , rangeH[[1]], rangeH[[2]]);
	nH2 <- runif(1 , rangeH2[[1]], rangeH2[[2]]);
	nH3 <- runif(1 , rangeH3[[1]], rangeH3[[2]]);
	nMaxGen <- floor(runif(1 , rangeGen[[1]], rangeGen[[2]]));
	nPopSize <- floor(runif(1 , rangePopSize[[1]], rangePopSize[[2]])); # draw from prior using uniform distribution.
	
	arrPopSizes <- rep(nPopSize, nMaxGen); #constant pop size drawn from the prior
	
	pMM <- nAnc^2;
	pBB <- (1-nAnc)^2;
	pBM_or_MB <- (1-pMM-pBB)/2;
	x<-c(pMM, pBM_or_MB, pBM_or_MB, pBB);

	nLoci = arrObsDeparture[["LociCount"]];
	nLociMat1 <- rbinom(1,nLoci,0.5);
	nLociMat2 <- nLoci - nLociMat1;
	
	arrFH <- {};
	arrD <- {};
	arrProp <- {};
	arrSimRet1 <- NULL;
	arrSimRet2 <- NULL;
	#Run simulation for each w matrix
	
	w1ToPass <- w_scenario1(nS, nH, nH2, nH3);
	for (i in 1:nLociMat1){ 
		arrSimRet1 <- fnSimulation(x, nMaxGen, w1ToPass, arrPopSizes, i);
		arrFH <- rbind(arrFH , arrSimRet1$FH);
		arrD <- rbind(arrD , arrSimRet1$D);
		arrProp <- c(arrProp , arrSimRet1$Prop);
	}
	
	w2ToPass <- w_scenario2(nS, nH, nH2, nH3);
	for (i in 1:nLociMat2){ 
		arrSimRet2 <- fnSimulation(x, nMaxGen, w2ToPass, arrPopSizes, nLociMat1 + i);
		arrFH <- rbind(arrFH , arrSimRet2$FH);
		arrD <- rbind(arrD , arrSimRet2$D);
		arrProp <- c(arrProp , arrSimRet2$Prop);
	}
	#Average the results of the two matrices while computing the summary statistics compared to real observed data
	arrSummaryStats <- fnObjectiveFunc(arrFH , arrD, arrProp);
			

	write.table(t(c(nAnc, nS, nH, nH2, nH3, nMaxGen, 
	nLociMat1,
	nLociMat2,
	nPopSize,
	arrSummaryStats[["DistHaploMean"]], 
	arrSummaryStats[["DistHaploVar"]], 
	arrSummaryStats[["DistDepartMean"]], 
	arrSummaryStats[["DistDepartVar"]],
	arrSummaryStats[["SimHaploMeans"]],
	arrSummaryStats[["SimHaploVars"]],
	arrSummaryStats[["SimDepartMeans"]],
	arrSummaryStats[["SimDepartVars"]],
	arrSimRet1[["RandomMatingHaplo"]],	
	arrSimRet2[["RandomMatingHaplo"]],	
	arrSummaryStats[["Prop"]])), sOutFile , sep="\t", append=TRUE, quote = FALSE, col.names = FALSE, row.names = FALSE);


}

