<?php
$sTaxaList = "taxa.txt";
$sAutapomorphicIn = "Xmal";
$sOutFile = "autapomorphicSNPS_list_$sAutapomorphicIn.txt";

$arrFasta = array();
$arrGenomeReaders = array();
$hTaxaList = fopen($sTaxaList , "r");

while(false !== ($sLn=fgets($hTaxaList))) {
	$sLn = trim($sLn);
	if ($sLn == "") {
		continue;
	}
	$arrFields = explode("\t", $sLn);
	$arrFasta[$arrFields[0]] = $arrFields[1];
}

/*
for( $i=0; $i<=40; $i++) {
echo(PHP_EOL.$oBir->NextBase()." ");
echo($oBir->GetCurrContig()." ");
echo($oBir->GetCurrIndex()." ");
}
*/

foreach($arrFasta as $sTaxon => $sFile) {
	$arrGenomeReaders[$sTaxon] = new GenomeFastaReader($sTaxon, $sFile);
}

$hOut = fopen($sOutFile , "w");
$bReadEnd = false;
$sCurrContig = "";
$bNewContigEncountered = false;
$arrContigNames = array();

fwrite($hOut, "Contig\tIndex\t");
fwrite($hOut, implode("\t",array_keys($arrFasta)).PHP_EOL);
$nSitesProccessed = 0;
while(true) {
	
	$i = -1;
	$arrBases = array();
	foreach($arrGenomeReaders as $sTaxon => $oReader) {
		$i++;
		$sBase = $oReader->NextBase();
		//echo($sBase);
		if ($sBase === -1) {
			$bReadEnd  = true; //exit;
			break;
		}
		
		if ($sBase === 0) {
			if ($i == 0) {
				$arrContigNames = array();
				$arrContigNames[$i] = $oReader->GetCurrContig();
				$bNewContigEncountered = true;
				
			}
			continue;
		}
		
		if (($sBase != 0) && $bNewContigEncountered) {
			die("Species $sTaxon is not aligned with the other species on contig $sCurrContig.");
		}
		
		if ($i==0) {
			$nSitesProccessed++;
			if ($nSitesProccessed % 10000==0) {
				echo(number_format($nSitesProccessed ,0,'.',',' )." sites proccessed...\r");
			}
		}
		
		
		$arrBases[$sTaxon] = $sBase;
	}
	
	if ($bNewContigEncountered) { //check if contig names in all fasta files are the same, other wise complaint.
	
		if (count(array_unique($arrContigNames)) != 1) {
			print_r($arrContigNames);
			die("Contig names do not agree in certain files!");
		}
		$bNewContigEncountered=false;
		$sCurrContig = $arrContigNames[0];
		echo("Processing contig: $sCurrContig ...".PHP_EOL);
		continue;
	}

	if ($bReadEnd) {
		break;
	}
	
	//do the actual comparison
	if (in_array("N", $arrBases)) {
		continue; //don't look at things with missing data
	}
	
	$nUniqueBaseCount = count(array_unique($arrBases));
	if ($nUniqueBaseCount  != 2) {
		continue; //if not biallelic
	}
	
	$sTargetTaxonBase = $arrBases[$sAutapomorphicIn];
	$arrBasesCp = $arrBases;
	unset($arrBasesCp[$sAutapomorphicIn]);
	
	if (!in_array($sTargetTaxonBase, $arrBasesCp)) { //if not found in other species, then this is unique to the species
		//output
		fwrite($hOut , str_replace("group", "", $sCurrContig)."\t".$arrGenomeReaders[$sAutapomorphicIn]->GetCurrIndex()."\t" );
		fwrite($hOut , implode("\t", $arrBases).PHP_EOL);
	}
}

class GenomeFastaReader {
	protected $sFastaFile;
	protected $sTaxon;
	protected $hF;
	protected $sCurrContig;
	protected $nCurrIndex; //snp index in the contig, start from 1.

	
	public function __construct( $sTaxonName, $sFasta) {
		$this->hF = fopen($sFasta , "r") or die("Failed to open $sFasta");
		$this->sTaxon = $sTaxonName;
	}
	
	public function NextBase($nCallLevel=0) {
		$sChar = fgetc($this->hF);
		if (false == $sChar) {
			return -1; // end of file.
		}
		
		$sChar = trim($sChar);
		if ($sChar == "") {
			$sChar = $this->NextBase($nCallLevel+1);
			$this->nCurrIndex--;
		}
		
		if ($sChar == ">" && $nCallLevel==0) {
			//new record
			//echo("new record");
			$this->sCurrContig = trim(fgets($this->hF));
			$this->nCurrIndex = 0;
			return 0; // new contig encountered
		}
		
		$this->nCurrIndex++;
		return strtoupper($sChar);
		
	}
	
	public function GetCurrContig() {
		return $this->sCurrContig;
	}
	
	public function GetCurrIndex() {
		return $this->nCurrIndex;
	}
}
?>