<?php
$nBinInterval = 0.01; // 0.01 cM interval
$nMaxDistance = 5; // up to 1 cM apart
$sPerCMLen = 378000; //378kb per cM
$sIn = "CALM.D.txt";
$sFilterFile = "autapomorphicSNPS_list_Xmal.txt";
//$sIn = "test.txt";
$sOut = $sIn."_wFilter_out.txt";

$arrFilter = array();
$nNumBins = round($nMaxDistance / $nBinInterval);
$nBinIntervalPhysical = $sPerCMLen * $nMaxDistance / $nNumBins;
$nMaxDistPhysical = $sPerCMLen * $nMaxDistance;
// initialize arrays
$arrSumD = array();
$arrCountD = array();

for($i=0;$i<$nNumBins;$i++) {
	$arrSumD[$i] = 0;
	$arrCountD[$i] = 0;
}

echo("Loading filter...\n");
//read filter
$hFilter = fopen($sFilterFile , "r");
if (!fgets($hFilter)) {
	die("Failed to read filter file.");
}

while(false!==($sLn = fgets($hFilter))) {
	$sLn = trim($sLn);
	if ($sLn == "") {
		continue;
	}
	
	$arrFields = explode("\t" , $sLn);
	if (!array_key_exists($arrFields[0], $arrFilter )) {
		$arrFilter[$arrFields[0]] = array();
	}
	$arrFilter[$arrFields[0]][$arrFields[1]] = 1;
	
}

echo("Processing file...\n");
//read file
$hIn = fopen($sIn , "r");

if (!fgets($hIn)) {
	die("Failed to read file.");
}

$nSitesProcessed = 0;
while(false!==($sLn = fgets($hIn))) {
	$sLn = trim($sLn);
	if ($sLn == "") {
		continue;
	}
	
	$arrFields = explode("\t" , $sLn);
	$sContig1 = $arrFields[0];
	$nCoord1 = $arrFields[1];
	$sContig2 = $arrFields[2];
	$nCoord2 = $arrFields[3];
	$nD = $arrFields[4];
	
	if ($sContig1 != $sContig2) {
		continue; //no need to look
	}
	
	//see if both in filter
	if ( (!fnInFilter($sContig1 , $nCoord1)) || (!fnInFilter($sContig2 , $nCoord2)) ) {
		continue;
	}
	
	$nPhysicalDist = abs($nCoord2 - $nCoord1);
	if ($nPhysicalDist >= $nMaxDistPhysical ) {
		continue;
	}
	$nWhichBin = floor($nPhysicalDist / $nBinIntervalPhysical);
	
	
	$arrSumD[$nWhichBin] = kahanSum($arrSumD[$nWhichBin] , $nD);
	$arrCountD[$nWhichBin] += 1;
	$nSitesProcessed++;
	
	if ($nSitesProcessed  % 10 ==0) {
		echo(" $nSitesProcessed pairs processed...\r");
	}
	
}

//output 

$hOut = fopen($sOut , "w");
fwrite($hOut, "BinNum\tBinStart_bp\tBinStop_bp\tBinStart_cM\tBinStop_cM\tDist_cM\tSumD\tCountD\tAvgD".PHP_EOL);

for($i=0;$i<$nNumBins;$i++) {
	$s = "";
	$s .= $i."\t";
	$s .= ($nBinIntervalPhysical*$i)."\t";
	$s .= ($nBinIntervalPhysical*($i+1) - 1)."\t";
	$s .= ($nBinInterval*$i)."\t";
	$s .= ($nBinInterval*($i+1))."\t";
	$s .= (($nBinInterval*$i) + ($nBinInterval*($i+1))) / 2 . "\t";
	$s .= $arrSumD[$i]."\t";
	$s .= $arrCountD[$i]."\t";
	if ($arrCountD[$i] == 0) {
		$s .= "NA".PHP_EOL;
	}
	else {
		$s .= ($arrSumD[$i] / $arrCountD[$i]).PHP_EOL;
		}
	fwrite($hOut, $s);
}

//avoids numerical issues when adding large number to small number.
function kahanSum() {
 $input = func_get_args();
 $sum = $input[0];
 $c = 0.0 ;         //A running compensation for lost low-order bits.
 for($i = 1 ; $i<count($input); $i++)
 {
	$y = $input[$i] - $c   ; //So far, so good: c is zero.
	$t = $sum + $y        ; //Alas, sum is big, y small, so low-order digits of y are lost.
	$c = ($t - $sum) - $y;   //(t - sum) recovers the high-order part of y; subtracting y recovers -(low part of y)
	$sum = $t;             //Algebraically, c should always be zero. Beware eagerly optimising compilers!
 	}
 return $sum;
}

function fnInFilter($sContig, $nIndex) {
	global $arrFilter;
	if (!array_key_exists($sContig, $arrFilter)) {
		return false;
	}
	
	return array_key_exists($nIndex, $arrFilter[$sContig]);
}
?>