source("libraryPath.R");
source("LDMeasures_func.R");

arrArgs <- commandArgs(trailingOnly = TRUE); # 1 - genotype file, 2 - "matrix_relatedness.txt", 3 - hybrid index file, 4 - number of block, 5 - total block

donnees <- read.table(arrArgs[1], header=TRUE, row.names=1, na.strings="NA");
donnees <- as.matrix(donnees);


nBlockNum <- as.integer(arrArgs[2]);
nTotalBlock <- as.integer(arrArgs[3]);
sOutFileName <- paste("result_block_", nBlockNum, ".txt", sep="");

cat(paste("Hashed LD.Measures block ", nBlockNum, " of ", nTotalBlock, " started\n", sep=""));
#system.time(ret1 <- LD.MeasuresHashed(subdonnees, relmatrix, hybindex, supinfo=TRUE,  doBlock=nBlockNum, totalBlocks=nTotalBlock )); 
system.time(ret1 <- LD.MeasuresHashed(donnees, doBlock=nBlockNum, totalBlocks=nTotalBlock, dumpFile=sOutFileName )); 
cat(paste("Hashed LD.Measures block ", nBlockNum, " of ", nTotalBlock, " done.\n", sep=""));
