<?php
require_once(dirname(__FILE__) . "/lib.php");

$sGenome1 = "/data/guest/schumer/Xbirchmanni_jhp_0.1_combined_mask10.fa";
$sGenome2 = "/data/guest/schumer/Xmalinche_jhp_0.1_combined_mask10.fa";
$arrGenomeNames = array("Xbir" , "Xmal");
$sDataFolder = "/data/guest/schumer/exons_ld_process/dat/";
$sOutputPrefix = "dNdS_results";

/*========================================================================*/

$hOutTable = fopen($sOutputPrefix."_counts.txt" , "w");
$hOutAA = fopen($sOutputPrefix."_AA.fasta" , "w");
$hOutDNA = fopen($sOutputPrefix."_DNA.fasta" , "w");
$hOutCodeml = fopen($sOutputPrefix."_Codeml.txt" , "w");

$oGenome1 = new FastaHack();
$oGenome2 = new FastaHack();

$oGenome1->SetDb($sGenome1);
$oGenome2->SetDb($sGenome2);
	
fwrite($hOutTable, "gene_id\tline\texon\ttotal_codons\tmorethanonebase_change\tidentical_codons\tsyn\tnsyn\tsyn_codon1\tsyn_codon2\tsyn_codon3\tnsyn_codon1\tnsyn_codon2\tnsyn_codon3\tmulti_codon1\tmulti_codon2\tmulti_codon3\tstopcodon_in_exon\tstop_codon_in_prev_exons".PHP_EOL);
fwrite($hOutCodeml, "gene_id\ttotal_codons\tdN\tdS\tdNdS\tN\tS".PHP_EOL);


foreach (glob($sDataFolder."/*") as $sFileName) {
   if (strpos($sFileName, "_blast_results") !== false) {
		continue;
   }

	$sGTF = $sFileName;//ENSXMAG00000001050";//ENSXMAG00000001400";//ENSXMAG00000000500//ENSXMAG00000000995//ENSXMAG00000001272

	if (!file_exists($sGTF)) {
		echo("Warning: $sGTF not found\n");
		continue;
	}

	$oGTF = new XiphoGTF();
	$oGTF->LoadGTF($sGTF);

	/*print_r($oGTF->arrGenes);
	die();*/
	foreach($oGTF->arrGenes as $sGeneName => $arrCDS) {
		echo($sGeneName.PHP_EOL);
		$sOrientation = $arrCDS[0]["orientation"];
		$sBlastFile = $sDataFolder."/".$sGeneName."_exon".$sOrientation."direction_blast_results";
		$arrFullCodingSeq = array(0=>"",1=>"");
		
		if (!file_exists($sBlastFile)) {
			echo("Warning: $sBlastFile doesn't exist, skipping exon...\n");
			continue;
		}
		
		$oBlastRet = new BlastTextRet();
		$oBlastRet->LoadText($sBlastFile);
		/*print_r($oBlastRet->arrQueries);
		die();*/
		
		//die();
		$nStopCodonInPrevExons = 0;
		foreach($arrCDS as $oExon ) {
			//$sExon = $oExon["exon"] ;
			$sExon = $oExon["line"] ;
			$nExonStart = $oExon["start"];
			$nExonEnd = $oExon["end"];
			$nExonLen = abs($nExonStart - $nExonEnd);
			$nExonStart = 1; //reset the start end to 1 base
			$nExonEnd = $nExonStart  + $nExonLen;
			
			$sBlastSubjectName = $sGeneName."_exon".$sOrientation."direction_".$sExon;
			if (!array_key_exists($sBlastSubjectName , $oBlastRet->arrQueries)) {
				echo("Exon $sBlastSubjectName has no hit, skipping...\n");
				continue;
			}
			
			echo("$sBlastSubjectName\n");
			$arrMapInfo = $oBlastRet->arrQueries[$sBlastSubjectName];
			//print_r($oExon);
			//print_r($arrMapInfo);
			//die();
			if (count($arrMapInfo) > 1) {
				echo("More than 1 blast hit of $sBlastSubjectName, skipping this exon...\n");
				continue;
			}
			$arrMapInfo1 = $arrMapInfo[0];
			$nSStart =  $arrMapInfo1["sstart"];
			$nSEnd = $arrMapInfo1["send"];
			$nQStart =  $arrMapInfo1["qstart"];
			$nQEnd = $arrMapInfo1["qend"];
			

			$nRealStart = $nRealEnd = 0;
			echo("sstart= $nSStart send=$nSEnd qstart=$nQStart qend=$nQEnd exonstart=$nExonStart exonend=$nExonEnd frame=". $oExon["frame"]."\n");
				
			if ($nSStart <$nSEnd) {
				//map the start stop
				$nRealStart = $nSStart - abs($nQStart - $nExonStart);
				$nRealEnd  = $nSEnd + abs($nExonEnd - $nQEnd );
			} else {
				$nRealStart = $nSEnd - abs($nExonEnd - $nQEnd );
				$nRealEnd  = $nSStart + abs($nQStart - $nExonStart);
			}
			
			$sDNA1 = $oGenome1->GetCDSRegion($arrMapInfo1["subject"], $nRealStart, $nRealEnd );
			$sDNA2 = $oGenome2->GetCDSRegion($arrMapInfo1["subject"], $nRealStart, $nRealEnd );
			
			if ( ($sOrientation=="-" && $nSStart <$nSEnd) || ($sOrientation=="+" && $nSStart >$nSEnd) ) {
				$sDNA1 = fnReverseComplement($sDNA1 );
				$sDNA2 = fnReverseComplement($sDNA2 );
			}
			$sDNA1 = substr($sDNA1 , $oExon["frame"]);
			$sDNA2 = substr($sDNA2 , $oExon["frame"]);
			$arrCleanedDNA = fnExludeCodonsWithN(array(0=>$sDNA1 , 1=> $sDNA2));
			
			/*
			echo("1: ".fnDNA2Peptide($sDNA1)[0].PHP_EOL);
			echo("2: ".fnDNA2Peptide($sDNA2)[0].PHP_EOL);	
			
			echo("clean 1: ".fnDNA2Peptide($arrCleanedDNA[0])[0].PHP_EOL);
			echo("clean 2: ".fnDNA2Peptide($arrCleanedDNA[1])[0].PHP_EOL);
			*/
			
			//print_r(fnCountdNdS($arrCleanedDNA));
			$arrCountRet = fnCountdNdS($arrCleanedDNA);
			$nStopCodonInPrevExons = $nStopCodonInPrevExons | $arrCountRet["stopcodon"];
			
			
			fwrite($hOutTable, $sGeneName."\t".$oExon["line"]."\t".$oExon["exon"]."\t".$arrCountRet["total_codons"]."\t".$arrCountRet["morethanonebase_change"]."\t".$arrCountRet["identical_codons"]."\t".$arrCountRet["syn"]."\t".$arrCountRet["nsyn"]."\t".$arrCountRet["S1"]."\t".$arrCountRet["S2"]."\t".$arrCountRet["S3"]."\t".$arrCountRet["N1"]."\t".$arrCountRet["N2"]."\t".$arrCountRet["N3"]."\t".$arrCountRet["M1"]."\t".$arrCountRet["M2"]."\t".$arrCountRet["M3"]."\t".$arrCountRet["stopcodon"]."\t".$nStopCodonInPrevExons.PHP_EOL);
			
			foreach($arrCountRet["proteins"] as $nKey => $sSeq) {
				fwrite($hOutAA , ">".$sBlastSubjectName."_".$arrGenomeNames[$nKey].PHP_EOL.$sSeq.PHP_EOL );
			}
			fwrite($hOutAA , ">".$sBlastSubjectName."_compare".PHP_EOL.$arrCountRet["aa_changes"].PHP_EOL );
			
			$nCounter=0;
			foreach($arrCountRet["DNAs"] as $nKey => $sSeq) {
				fwrite($hOutDNA , ">".$sBlastSubjectName."_".$arrGenomeNames[$nKey].PHP_EOL.$sSeq.PHP_EOL );
				$arrFullCodingSeq[$nCounter] .= $sSeq;
				$nCounter++;
			}
			fwrite($hOutDNA , ">".$sBlastSubjectName."_compare".PHP_EOL.$arrCountRet["DNA_changes"].PHP_EOL );
			
		}
		
		//do Codeml
		if ($nStopCodonInPrevExons == 0) { //there is no stop codon, do codeml
			$oCodeml = new CodemlUtil();
			$nSeqLen = 0;
			foreach($arrFullCodingSeq as $sKey => $sSeq) {
				$oCodeml->AddSequence($sKey , $sSeq);
				$nSeqLen = strlen( $sSeq);
			}
			$oCodeml->SpecifyTree("(0,1);");
			$arrCodemlRet = $oCodeml->RunCodeml(true); //only need to get dn ds
			fwrite($hOutCodeml, "$sGeneName\t".($nSeqLen/3)."\t".$arrCodemlRet["dN"]."\t".$arrCodemlRet["dS"]."\t".$arrCodemlRet["dNdS"]."\t".$arrCodemlRet["N"]."\t".$arrCodemlRet["S"].PHP_EOL);
		}
		

	}
	
}

?>