parents1<-read.csv(file="pop1_parents",sep="\t",head=FALSE)
parents2<-read.csv(file="pop2_parents",sep="\t",head=FALSE)

#determine if sites have frequency differences in the parents
pop1_site1<-((mean(parents1$V1,na.rm=TRUE))-(mean(parents1$V3,na.rm=TRUE)))
pop1_site2<-((mean(parents1$V2,na.rm=TRUE))-(mean(parents1$V4,na.rm=TRUE)))
pop2_site1<-((mean(parents2$V1,na.rm=TRUE))-(mean(parents2$V3,na.rm=TRUE)))
pop2_site2<-((mean(parents2$V2,na.rm=TRUE))-(mean(parents2$V4,na.rm=TRUE)))

if((abs(pop1_site1)>=0.9)&(abs(pop1_site2)>=0.9)&(abs(pop2_site1)>=0.9)&(abs(pop2_site2)>=0.9)){

pop1<-read.csv(file="outms_pop1_final",sep="\t",head=FALSE)

w=seq(1,340,by=2)

data1<-list()
data2<-list()

for (x in 1:168){

y=w+1

q=w[x]
r=y[x]

set1<-as.data.frame(pop1$V1)
set2<-as.data.frame(pop1$V2)

geno1<-(set1[q,])+set1[r,]
geno2<-(set2[q,])+set2[r,]

data1<-rbind(data1,geno1,deparse.level=0)
data2<-rbind(data2,geno2,deparse.level=0)
}

r2_pop1<-(cor.test(c(as.numeric(data1)),c(as.numeric(data2)))$estimate)

model="NA"
t="NA"

library(arm)
model <-bayespolr(as.factor(c(as.numeric(data1))) ~ c(as.numeric(data2)))
p_pop1<-2*pt(-abs(summary(model)$coefficients[7]),170-2)

write.table(cbind(r2_pop1,p_pop1,mean(as.numeric(data1)),mean(as.numeric(data2))),file="simulated_mig_rsquared_p_freqs_pop1.csv",append=TRUE,col.names=FALSE,row.names=FALSE,sep="\t")

#now run pop2

pop2<-read.csv(file="outms_pop2_final",sep="\t",head=FALSE)

w=seq(1,340,by=2)

data1<-list()
data2<-list()

for (x in 1:146){

y=w+1

q=w[x]
r=y[x]

set1<-as.data.frame(pop2$V1)
set2<-as.data.frame(pop2$V2)

geno1<-(set1[q,])+set1[r,]
geno2<-(set2[q,])+set2[r,]

data1<-rbind(data1,geno1,deparse.level=0)
data2<-rbind(data2,geno2,deparse.level=0)
}

r2_pop2<-(cor.test(c(as.numeric(data1)),c(as.numeric(data2)))$estimate)

model="NA"
t="NA"

library(MASS)
model <-bayespolr(as.factor(c(as.numeric(data1))) ~ c(as.numeric(data2)))
p_pop2<-2*pt(-abs(summary(model)$coefficients[7]),146-2)

write.table(cbind(r2_pop2,p_pop2,mean(c(as.numeric(data1))),mean(as.numeric(c(data2)))),file="simulated_mig_rsquared_p_freqs_pop2.csv",append=TRUE,col.names=FALSE,row.names=FALSE,sep="\t")

}

